
/* 
MathModule
For Resound 2.4
Sean Luke
Jan 20 1996

An example math transform module, including reversing, inverting,
abs, volume and vertical shifting.  This module includes a custom
nib file and several menu additions to Resound's Modules menu.

INTEL READY


Copyright (c) 1996 by Sean Luke

Permission to use, copy, modify, and distribute this material 
for any purpose and without fee is hereby granted.  SEAN LUKE 
MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY 
OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS", 
WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES.

*/

#import "Module.h"

@interface MathModule:Module
{
	BOOL nib_loaded;		// panels have been loaded
	id	multiplyPanel;
	id	percentChangeScroller;
	id	percentChangeField;
	id	shiftPanel;
	id	shiftSliderValue;
}

- init;
- reverseIt:sender;			// reverse, but keep channels correct
- invertIt:sender;			// invert
- absIt:sender;				// perform absolute value
- shiftIt:sender;			// changing vertical position
- multiplyIt:sender;		// changing volume
- showShiftPanel:sender;
- showMultiplyPanel:sender;
- halve:sender;
- double:sender;
- maximize:sender;

@end
